$(document).ready(function()
{
    if(v.dept) $('#category' + v.dept).parent('li').addClass('active');

    $('.setting').click(function()
    {
        $.openEntry('crm', $(this).attr('href'));
        return false;
    });

    /* Add an item. */
    $(document).on('click', '.add', function()
    {
        $(this).parents('tr').after(v.itemRow.replace(/key/g, v.key));
        var chosenDefaultOptions = {no_results_text: v.noResultsMatch, disable_search_threshold: 1, search_contains: true, width: '100%', allow_single_deselect: true};
        $(".chosen").chosen(chosenDefaultOptions);
        v.key++;
    })

    /* Remove an item. */
    $(document).on('click', '.remove', function()
    {
        if($('.remove').size() == 1)
        {
            $(this).parents('tr').find('input,select').val('');
            $(this).parents('tr').find('.chosen').trigger('chosen:updated');
            return;
        }
        $(this).parents('tr').remove();
    })

    $(document).on('change', '[name*=lines]', function()
    {
        $(this).parents('tr').find('[name^=rates]').change();
    });

    /* Calculate remain rate. */
    $(document).on('change', '[name^=rates]', function()
    {
        rate = $(this).val();
        if(!isNaN(rate))
        {
            var $remainRate = $(this).parents('tr').find('#remainRates');
            var line = $(this).parents('tr').find('[name^=lines]').val();
            var remainUrl = createLink('commission', 'getRemainRates', 'line=' + line + '&account=' + window.btoa(v.account));

            $.get(remainUrl, function(data)
            {
                remainRate = data.replace("%", "") - rate;
                if(line) $remainRate.text(remainRate + "%");
            });
        }
    });

    $('[name*=lines]').change();
})
